︠7c12ca92-f39c-4ef7-893b-ea744ca02bcas︠
def neighbors(g,v):
    N = []
    E = g.edges(labels=False)
    for w in g.vertices():
        if (v,w) in E or (w,v) in E:
            N.append(w)
    return N
︡3cd87b04-af83-4eee-8de3-27d0f1908557︡{"done":true}︡
︠e0f96e26-20ea-42be-8e97-01eb6f23a614s︠
pete = graphs.PetersenGraph()
︡ae1708d8-9350-45de-8af9-075cd6ea3cd6︡{"done":true}︡
︠a7f427d1-2b8a-4be4-a643-f61309541a74s︠
neighbors(pete,0)
︡7fa0fc4d-e3a1-422e-a51d-df6853613fcd︡{"stdout":"[1, 4, 5]\n"}︡{"done":true}︡
︠bb06e6aa-4289-49a8-aacf-0c0e222caf34s︠
def remove_vertex_and_neighbors(g,v):
    S2=g.vertices()
    S2.remove(v)
    for w in neighbors(g,v):
        S2.remove(w)
    return g.subgraph(S2)
︡a6030e2e-2576-492f-9d5d-07e2c5f11f4a︡{"done":true}︡
︠21bfe42b-6c54-4752-9c2a-e9ea985e88bas︠
def tt_maximum_independent_set(g, IndependentSet):
    V = g.vertices()
    if V == []:
        return IndependentSet
    v = V.pop()
    S1 = V
    S2 = remove_vertex_and_neighbors(g,v)
    g1 = g.subgraph(S1)
    g2 = g.subgraph(S2)
    Max1 = tt_maximum_independent_set(g1, IndependentSet)
    Max2 = tt_maximum_independent_set(g2, IndependentSet+[v])
    if len(Max1) > len(Max2):
        return Max1
    else:
        return Max2
︡7048a7a0-7a84-4c32-9cea-f7e03010a271︡{"done":true}︡
︠056ea13e-c217-4377-8099-10c92fc6dbe4s︠
tt_maximum_independent_set(pete,[])
︡5efc6741-b2d3-4cab-a539-4b6f69197a67︡{"stdout":"[9, 8, 2, 0]"}︡{"stdout":"\n"}︡{"done":true}︡
︠7572d1db-d028-4a00-a09c-940554473730s︠
def tt_independence_number(g):
    return len(tt_maximum_independent_set(g,[]))
︡1b81e979-281c-4097-825b-643021a7698f︡{"done":true}︡
︠38a30469-a87e-4a03-a3da-f72ce02941d8s︠
tt_independence_number(pete)
︡5890768a-ffbc-4e26-b603-47c2526521e0︡{"stdout":"4\n"}︡{"done":true}︡
︠59128841-c62b-4a55-9dc2-2113e56635f5s︠
pete.is_independent_set([0,1])
︡8c4b597c-274f-49ad-9ab7-9c9352957990︡{"stdout":"False\n"}︡{"done":true}︡
︠3accc411-1cc3-48f4-8b0e-5ae6d729720as︠
def naive_maximum_independent_set(g):
    largest = 0
    independent = []
    L=subsets(g.vertices())
    for S in L:
        if g.is_independent_set(S):
            if len(S) > largest:
                largest = len(S)
                independent = S
    return independent
︡4852b1d1-0c91-481e-96a2-229adfdf6b49︡{"done":true}︡
︠2fa2a564-e72f-4dc7-b4b0-f7000ed4a07es︠
naive_maximum_independent_set(pete)
︡42762dac-9879-41e1-ba98-c600b1725204︡{"stdout":"[2, 4, 5, 6]"}︡{"stdout":"\n"}︡{"done":true}︡
︠7334c872-2434-45bb-86c3-ad35243fada3s︠
pete.show()
︡1d806982-3658-4f3f-9f9b-3cd8fca96169︡{"file":{"filename":"/home/user/.sage/temp/project-55450917-a8b2-413a-a2ee-7a3a8d377d6d/375/tmp_uFIMRs.svg","show":true,"text":null,"uuid":"76ee404b-dbb7-4a5d-95ab-1af615177045"},"once":false}︡{"done":true}︡
︠a12e1c4f-779c-420a-bd7b-968b3b5fb430s︠
def naive_independence_number(g):
    return len(naive_maximum_independent_set(g))
︡4a2c3eeb-9241-41b7-83a2-a9eb2c57bd9b︡{"done":true}︡
︠77ef9887-b913-4b49-baba-f812affdbcf5s︠

naive_independence_number(pete)
︡fd54ad94-4652-49dc-b631-45c2e8dbb45f︡{"stdout":"4\n"}︡{"done":true}︡
︠5f47964c-ead1-484a-8e08-bc06f50c4d56s︠
timeit("naive_independence_number(pete)")
︡8a757438-2f77-43bf-b124-b759092484ac︡{"stdout":"5 loops, best of 3: 93 ms per loop"}︡{"stdout":"\n"}︡{"done":true}︡
︠7e3c525e-fc3e-4cad-ad4b-a3ee03471fb9s︠
timeit("tt_independence_number(pete)")
︡66426235-0dd2-4bb1-98d5-cbd4c6281044︡{"stdout":"25 loops, best of 3: 15.1 ms per loop"}︡{"stdout":"\n"}︡{"done":true}︡
︠67b7af28-18e7-4651-bc91-7d47cce142cfs︠
pete.independent_set(value_only = True)
︡8797cac2-df5d-4e13-b09c-1ec02f67702c︡{"stdout":"4\n"}︡{"done":true}︡
︠547496a7-020e-4e72-9589-56c7c5d45360s︠
timeit("pete.independent_set(value_only = True)")
︡c2cb6f25-0174-4c4c-8c06-30990b2c6aab︡{"stdout":"625 loops, best of 3: 281 µs per loop"}︡{"stdout":"\n"}︡{"done":true}︡
︠1996524a-2c31-46f8-a21c-fcce8cd73f45s︠
dodo = graphs.DodecahedralGraph()
︡f2b7487e-dbb8-40cd-88e6-89bd417a4b18︡{"done":true}︡
︠ab756aef-c9df-4e78-8b61-44341590e6d1s︠
dodo.show()
︡94933425-afd8-41c1-a917-62b2e358e9d8︡{"file":{"filename":"/home/user/.sage/temp/project-55450917-a8b2-413a-a2ee-7a3a8d377d6d/375/tmp_xqK2S0.svg","show":true,"text":null,"uuid":"fba8194a-b4d2-401a-8769-69b9432a1a75"},"once":false}︡{"done":true}︡
︠11bea674-87b4-464b-b49e-287019af51aes︠
timeit("tt_independence_number(dodo)")
︡a33e7d64-9b0a-42e6-9277-23a666bb372c︡{"stdout":"5 loops, best of 3: 1.19 s per loop"}︡{"stdout":"\n"}︡{"done":true}︡
︠0f665318-8e8c-4d25-8128-b5996689e52as︠
timeit("dodo.independent_set(value_only = True)")
︡b4ec0bcb-b45f-4933-9507-375a7c845d19︡{"stdout":"625 loops, best of 3: 614 µs per loop"}︡{"stdout":"\n"}︡{"done":true}︡
︠953dd7e2-8dfe-431b-8f92-a95b249b2f95s︠
timeit("naive_independence_number(dodo)")
︡897bd6f7-f324-48c0-aa1a-d9245630cef0︡{"stdout":"5 loops, best of 3: 168 s per loop"}︡{"stdout":"\n"}︡{"done":true}︡
︠4bc7eda4-6938-4c98-8af1-4182294a7df9︠









